/* Copyright (c) Michael L. Scott, 2001, 2002 */

#include "thread_data.h"

/*
    Allocate space for thread stack, aligned so we can easily find
    static data at the bottom.
    Call appropriate initializers for that static data.
*/
void *new_stack(int tid)
{
    thread_data *p = (thread_data *) memalign(STACK_SIZE, STACK_SIZE);
    void *stack = (void *) (p + 1);
    init_local_hn(&p->lhn);
    p->recent_time = p->time_countdown = 0;
        /* initialization not strictly necessary, but what the heck */
    p->tid = tid;
    return stack;
}

size_t stack_size()
{
    return STACK_SIZE - sizeof(thread_data);
}

#ifndef __GNUC__

thread_data *my_thread_data()
{
    int dummy;
    return (thread_data *) (((unsigned long) (&dummy))
                            & ((unsigned long) (- ((int) STACK_SIZE))));
}

#endif
